Index: /trunk/kernel/kern/rpc.c
===================================================================
--- /trunk/kernel/kern/rpc.c	(revision 656)
+++ /trunk/kernel/kern/rpc.c	(revision 657)
@@ -2478,5 +1066,5 @@
 
 /////////////////////////////////////////////////////////////////////////////////////////
-// [26]  Marshaling functions attached to RPC_VMM_REMOVE_VSEG 
+// [16]  Marshaling functions attached to RPC_VMM_REMOVE_VSEG 
 /////////////////////////////////////////////////////////////////////////////////////////
 
@@ -2560,5 +1148,5 @@
 
 /////////////////////////////////////////////////////////////////////////////////////////
-// [27]          Marshaling functions attached to RPC_VMM_CREATE_VSEG 
+// [17]          Marshaling functions attached to RPC_VMM_CREATE_VSEG 
 /////////////////////////////////////////////////////////////////////////////////////////
 
@@ -2662,5 +1250,5 @@
 
 /////////////////////////////////////////////////////////////////////////////////////////
-// [28]          Marshaling functions attached to RPC_VMM_SET_COW 
+// [18]          Marshaling functions attached to RPC_VMM_SET_COW 
 /////////////////////////////////////////////////////////////////////////////////////////
 
@@ -2730,10 +1318,295 @@
 }
 
+
+
+/////////////////////////////////////////////////////////////////////////////////////////
+/////////////////////////////////////////////////////////////////////////////////////////
+//                            DEPRECATED RPCs
+/////////////////////////////////////////////////////////////////////////////////////////
+/////////////////////////////////////////////////////////////////////////////////////////
+
+/*
+
+/////////////////////////////////////////////////////////////////////////////////////////
+// [0]       RPC_PMEM_GET_PAGES deprecated [AG] May 2019
+/////////////////////////////////////////////////////////////////////////////////////////
+void rpc_pmem_get_pages_client( cxy_t      cxy,
+                                uint32_t   order,      // in 
+                                page_t  ** page )      // out 
+{
+#if DEBUG_RPC_PMEM_GET_PAGES
+thread_t * this = CURRENT_THREAD;
+uint32_t cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_RPC_PMEM_GET_PAGES )
+printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
+#endif
+
+    uint32_t responses = 1;
+
+    // initialise RPC descriptor header 
+    rpc_desc_t  rpc;
+    rpc.index     = RPC_PMEM_GET_PAGES;
+    rpc.blocking  = true;
+    rpc.rsp       = &responses;
+
+    // set input arguments in RPC descriptor 
+    rpc.args[0] = (uint64_t)order;
+
+    // register RPC request in remote RPC fifo
+    rpc_send( cxy , &rpc );
+
+    // get output arguments from RPC descriptor
+    *page = (page_t *)(intptr_t)rpc.args[1];
+
+#if DEBUG_RPC_PMEM_GET_PAGES
+cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_RPC_PMEM_GET_PAGES )
+printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
+#endif
+}
+
+///////////////////////////////////////////
+void rpc_pmem_get_pages_server( xptr_t xp )
+{
+#if DEBUG_RPC_PMEM_GET_PAGES
+thread_t * this = CURRENT_THREAD;
+uint32_t cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_RPC_PMEM_GET_PAGES )
+printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
+#endif
+
+    // get client cluster identifier and pointer on RPC descriptor
+    cxy_t        cxy  = GET_CXY( xp );
+    rpc_desc_t * desc = GET_PTR( xp );
+
+    // get input arguments from client RPC descriptor
+    uint32_t order = (uint32_t)hal_remote_l64( XPTR( cxy , &desc->args[0] ) );
+    
+    // call local pmem allocator
+    page_t * page = ppm_alloc_pages( order ); 
+
+    // set output arguments into client RPC descriptor
+    hal_remote_s64( XPTR( cxy , &desc->args[1] ) , (uint64_t)(intptr_t)page );
+
+#if DEBUG_RPC_PMEM_GET_PAGES
+cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_RPC_PMEM_GET_PAGES )
+printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
+#endif
+}
+
+/////////////////////////////////////////////////////////////////////////////////////////
+// [1]       RPC_PMEM_RELEASE_PAGES deprecated [AG] may 2019
+/////////////////////////////////////////////////////////////////////////////////////////
+void rpc_pmem_release_pages_client( cxy_t     cxy,
+                                    page_t  * page )      // out 
+{
+#if DEBUG_RPC_PMEM_RELEASE_PAGES
+thread_t * this = CURRENT_THREAD;
+uint32_t cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_RPC_PMEM_RELEASE_PAGES )
+printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
+#endif
+
+    uint32_t responses = 1;
+
+    // initialise RPC descriptor header 
+    rpc_desc_t  rpc;
+    rpc.index    = RPC_PMEM_RELEASE_PAGES;
+    rpc.blocking = true;
+    rpc.rsp      = &responses;
+
+    // set input arguments in RPC descriptor 
+    rpc.args[0] = (uint64_t)(intptr_t)page;
+
+    // register RPC request in remote RPC fifo
+    rpc_send( cxy , &rpc );
+
+#if DEBUG_RPC_PMEM_RELEASE_PAGES
+cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_RPC_PMEM_RELEASE_PAGES )
+printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
+#endif
+}
+
+///////////////////////////////////////////////
+void rpc_pmem_release_pages_server( xptr_t xp )
+{
+#if DEBUG_RPC_PMEM_RELEASE_PAGES
+thread_t * this = CURRENT_THREAD;
+uint32_t cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_RPC_PMEM_RELEASE_PAGES )
+printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
+#endif
+
+    // get client cluster identifier and pointer on RPC descriptor
+    cxy_t        cxy  = GET_CXY( xp );
+    rpc_desc_t * desc = GET_PTR( xp );
+
+    // get input arguments from client RPC descriptor
+    page_t * page = (page_t *)(intptr_t)hal_remote_l64( XPTR( cxy , &desc->args[0] ) );
+    
+    // release memory to local pmem 
+    kmem_req_t req;
+    req.type = KMEM_PPM;
+    req.ptr  = page;
+    kmem_free( &req );
+
+#if DEBUG_RPC_PMEM_RELEASE_PAGES
+cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_RPC_PMEM_RELEASE_PAGES )
+printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
+#endif
+}
+
+/////////////////////////////////////////////////////////////////////////////////////////
+// [2]          RPC_PPM_DISPLAY deprecated [AG] May 2019    
+/////////////////////////////////////////////////////////////////////////////////////////
+void rpc_ppm_display_client( cxy_t  cxy )
+{
+#if DEBUG_RPC_PPM_DISPLAY
+thread_t * this = CURRENT_THREAD;
+uint32_t cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_RPC_PPM_DISPLAY )
+printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
+#endif
+
+    uint32_t responses = 1;
+
+    // initialise RPC descriptor header 
+    rpc_desc_t  rpc;
+    rpc.index    = RPC_PPM_DISPLAY;
+    rpc.blocking = true;
+    rpc.rsp      = &responses;
+
+    // register RPC request in remote RPC fifo
+    rpc_send( cxy , &rpc );
+
+#if DEBUG_RPC_PPM_DISPLAY
+cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_RPC_PPM_DISPLAY )
+printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
+#endif
+}
+
+////////////////////////////////////////////////////////////////////
+void rpc_ppm_display_server( xptr_t __attribute__((__unused__)) xp )
+{
+#if DEBUG_RPC_PPM_DISPLAY
+thread_t * this = CURRENT_THREAD;
+uint32_t cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_RPC_PPM_DISPLAY )
+printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
+#endif
+
+    // call local kernel function
+    ppm_display();
+
+#if DEBUG_RPC_PPM_DISPLAY
+cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_RPC_PPM_DISPLAY )
+printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
+#endif
+}
+
+/////////////////////////////////////////////////////////////////////////////////////////
+// [8]   RPC_VFS_FS_UPDATE_DENTRY deprecated [AG] dec 2019
+/////////////////////////////////////////////////////////////////////////////////////////
+void rpc_vfs_fs_update_dentry_client( cxy_t          cxy,
+                                      vfs_inode_t  * inode,
+                                      vfs_dentry_t * dentry,
+                                      uint32_t       size,
+                                      error_t      * error )
+{
+#if DEBUG_RPC_VFS_FS_UPDATE_DENTRY
+thread_t * this = CURRENT_THREAD;
+uint32_t cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_RPC_VFS_FS_UPDATE_DENTRY )
+printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
+#endif
+
+    uint32_t responses = 1;
+
+    // initialise RPC descriptor header 
+    rpc_desc_t  rpc;
+    rpc.index    = RPC_VFS_FS_UPDATE_DENTRY;
+    rpc.blocking = true;
+    rpc.rsp      = &responses;
+
+    // set input arguments in RPC descriptor 
+    rpc.args[0] = (uint64_t)(intptr_t)inode;
+    rpc.args[1] = (uint64_t)(intptr_t)dentry;
+    rpc.args[2] = (uint64_t)size;
+
+    // register RPC request in remote RPC fifo
+    rpc_send( cxy , &rpc );
+
+    // get output values from RPC descriptor
+    *error   = (error_t)rpc.args[3];
+
+#if DEBUG_RPC_VFS_FS_UPDATE_DENTRY
+cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_RPC_VFS_FS_UPDATE_DENTRY )
+printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
+#endif
+}
+
+/////////////////////////////////////////////////
+void rpc_vfs_fs_update_dentry_server( xptr_t xp )
+{
+#if DEBUG_RPC_VFS_FS_UPDATE_DENTRY
+thread_t * this = CURRENT_THREAD;
+uint32_t cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_RPC_VFS_FS_UPDATE_DENTRY )
+printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
+#endif
+
+    error_t        error;
+    vfs_inode_t  * inode;
+    vfs_dentry_t * dentry;
+    uint32_t       size;
+
+    // get client cluster identifier and pointer on RPC descriptor
+    cxy_t        client_cxy  = GET_CXY( xp );
+    rpc_desc_t * desc        = GET_PTR( xp );
+
+    // get input arguments
+    inode  = (vfs_inode_t*)(intptr_t) hal_remote_l64(XPTR(client_cxy , &desc->args[0]));
+    dentry = (vfs_dentry_t*)(intptr_t)hal_remote_l64(XPTR(client_cxy , &desc->args[1]));
+    size   = (uint32_t)               hal_remote_l64(XPTR(client_cxy , &desc->args[2]));
+
+    // call the kernel function
+    error = vfs_fs_update_dentry( inode , dentry , size );
+
+    // set output argument
+    hal_remote_s64( XPTR( client_cxy , &desc->args[3] ) , (uint64_t)error );
+
+#if DEBUG_RPC_VFS_FS_UPDATE_DENTRY
+cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_RPC_VFS_FS_UPDATE_DENTRY )
+printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
+#endif
+}
+
+
 /////////////////////////////////////////////////////////////////////////////////////////
 // [29]      RPC_VMM_DISPLAY deprecated [AG] June 2019
 /////////////////////////////////////////////////////////////////////////////////////////
-
-/*
-/////////////////////////////////////////////
 void rpc_hal_vmm_display_client( cxy_t       cxy,
                              process_t * process,
